import { Sequence, Class, Var, Func } from '../../../../WebPd_compiler/dist/src/ast/declare.js';
import '../../../../WebPd_compiler/dist/src/stdlib/fs.js';
import '../../../../WebPd_compiler/dist/src/compile/precompile/nodes.js';
import { generateVariableNamesNodeType } from '../variable-names.js';

const EMPTY_BUS_NAME = 'empty';
const build = () => ({
    inlets: {
        '0': { type: 'message', id: '0' },
    },
    outlets: {
        '0': { type: 'message', id: '0' },
    },
    // This is always true, because the object can receive 
    // messages through message bus
    isPushingMessages: true
});
// TODO : move to global code
const controlsCoreVariableNames = generateVariableNamesNodeType('control', [
    'setReceiveBusName',
    'setSendReceiveFromMessage',
    'defaultMessageHandler',
]);
const controlsCore = () => Sequence([
    Class(controlsCoreVariableNames.stateClass, [
        Var('Float', 'minValue'),
        Var('Float', 'maxValue'),
        Var('Float', 'valueFloat'),
        Var('Message', 'value'),
        Var('string', 'receiveBusName'),
        Var('string', 'sendBusName'),
        Var('(m: Message) => void', 'messageReceiver'),
        Var('(m: Message) => void', 'messageSender'),
    ]),
    Func(controlsCoreVariableNames.setReceiveBusName, [
        Var(controlsCoreVariableNames.stateClass, 'state'),
        Var('string', 'busName'),
    ], 'void') `
        if (state.receiveBusName !== "${EMPTY_BUS_NAME}") {
            msgBusUnsubscribe(state.receiveBusName, state.messageReceiver)
        }
        state.receiveBusName = busName
        if (state.receiveBusName !== "${EMPTY_BUS_NAME}") {
            msgBusSubscribe(state.receiveBusName, state.messageReceiver)
        }
    `,
    Func(controlsCoreVariableNames.setSendReceiveFromMessage, [
        Var(controlsCoreVariableNames.stateClass, 'state'),
        Var('Message', 'm'),
    ], 'boolean') `
        if (
            msg_isMatching(m, [MSG_STRING_TOKEN, MSG_STRING_TOKEN])
            && msg_readStringToken(m, 0) === 'receive'
        ) {
            ${controlsCoreVariableNames.setReceiveBusName}(state, msg_readStringToken(m, 1))
            return true

        } else if (
            msg_isMatching(m, [MSG_STRING_TOKEN, MSG_STRING_TOKEN])
            && msg_readStringToken(m, 0) === 'send'
        ) {
            state.sendBusName = msg_readStringToken(m, 1)
            return true
        }
        return false
    `,
    Func(controlsCoreVariableNames.defaultMessageHandler, [Var('Message', 'm')], 'void') ``,
]);

export { EMPTY_BUS_NAME, build, controlsCore, controlsCoreVariableNames };
